function varargout=eval3Ds03(varargin)
  % Th=fc_simesh.demos.eval3Ds03('geofile','sphere8surf','N',10,'verbose',2,'MshFileVersion','4.1','force',true);
  fprintf('************************************\n')
  fprintf('  Running %s function\n',mfilename())
  fprintf('************************************\n')
  [Th,verbose]=fc_simesh.demos.setMesh3Ds(varargin{:});
  
  fu=@(x,y,z) cos(3*x).*sin(4*y).*z;
  u=Th.feval(fu);
  
  f={@(x,y,z) cos(2*x).*sin(3*y).*exp(z), 1 ,u,@(q) cos(4*q(1,:)).*sin(5*q(2,:)).*exp(q(3,:))};
  
  g={@(x,y,z) cos(2*x).*sin(3*y).*exp(z), @(x,y,z) 1 ,fu, @(x,y,z) cos(4*x).*sin(5*y).*exp(z)};

  if verbose,fprintf('*** Computing functions on mesh\n');end
  V1=Th.eval(f);  % V1  Th.nq-by-4
  V2=Th.feval(g); % V2  Th.nq-by-4
  
  if verbose,fprintf('*** Check results\n');end
  res=0;
  res=res+ ~( all(size(V1)==[Th.nq,4]) && all(size(V2)==[Th.nq,4]) );
  if verbose, if (res==1),    fprintf('  Test 0: failed with dimensions\n');else fprintf('  Test 0: OK\n');end;end
  E=sum(size(V1)~=size(V2)); % return 0 if same size
  res=res+(E >1e-15);
  if verbose, if (E >1e-15),fprintf('  Test 1: failed with size(V1)=[%s] and size(V2)=[%s]\n',num2str(size(V1)),num2str(size(V2)));else fprintf('  Test 1: OK\n');end;end
  if E==0
    E=norm(V1-V2,Inf);
    res=res+(E >1e-15);
    if verbose, if (E >1e-15),fprintf('  Test 2: failed with E=%g\n',E);else fprintf('  Test 2: OK\n');end;end
  end
  if res>0,error('demo % failed',mfilename()');end
  if nargout==1,varargout{1}=Th;end
end


